%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%
%%                                                                      %%
%%  ClientServer tool: dserver application                              %%
%%                                                                      %%
%%  (c) 2000 Universit catholique de Louvain.  All Rights Reserved.    %%
%%  The development of ClientServer is supported by the PIRATES project %%
%%  at the Universit catholique de Louvain.  This file is subject to   %%
%%  the general Mozart license.                                         %%
%%                                                                      %%
%%  Author: Peter Van Roy                                               %%
%%                                                                      %%
%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%%


functor
import Application Connection Module Pickle Fault
define
   proc {LocalWatcher E FS W S}
      {Fault.installWatcher E FS W _}
      try 
	 {S}
      finally 
	 {Fault.deInstallWatcher E W _}
      end 
   end

   proc {Guard E FS S1 S2}
      N={NewName}
      T={Thread.this}
      proc {W E FS} {Thread.injectException T N} end 
   in 
      {Fault.enable E 'thread'(T) nil _}
      try 
	 {LocalWatcher E FS W S1}
      catch X then 
	 if X==N then 
	    {S2}
	 else 
	    raise X end 
	 end 
      end 
   end
   
   Args={Application.getArgs 
	 record('in'(single type:string)
		publish(single type:string))}
   [Server]={Module.link [Args.'in']}
   Q=Server.query
   S P {NewPort S P}
   {Pickle.save {Connection.offerUnlimited P} Args.publish}
   thread
      {ForAll S
       proc {$ E#R#Sync}
	  SL in
	  try R={Q E} SL=unit catch X then SL=X end
	  {Guard Sync [permFail]
	   proc {$} Sync=SL end
	   proc {$} skip end}
       end}
   end 
end
